
Redmine - Feature #16904

Add anonymous user to users list in query filters

2014-05-16 15:42 - Felix Schäfer

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Jean-Philippe Lang % Done: 0%

Category: Issues filter Estimated time: 0.00 hour

Target version: 4.1.0   

Resolution: Fixed   

Description

The author of an issue might be "Anonymous", either because issue creation is allowed for users that are not logged in, or because a

user has been deleted. There's currently no way to filter by that user, the only way to achieve this is to filter for issues with an author

that "is not all users".

Associated revisions

Revision 19065 - 2019-11-10 08:58 - Jean-Philippe Lang

Add anonymous user to author list in issue/time query (#16904).

Patch by Yuichi HARADA and Go MAEDA.

Revision 19066 - 2019-11-10 08:59 - Jean-Philippe Lang

Merged r19065 to 4.1-stable (#16904).

Revision 19067 - 2019-11-13 10:49 - Go MAEDA

Fix that QueriesControllerTest fails due to r19065 (#16904).

Patch by Marius BALTEANU.

Revision 19068 - 2019-11-13 14:22 - Go MAEDA

Fix a Rubocop offense caused by r19065 (#16904).

Patch by Marius BALTEANU.

Revision 19069 - 2019-11-13 14:24 - Go MAEDA

Merged r19067 from trunk to 4.1-stable (#16904).

Revision 19070 - 2019-11-13 14:25 - Go MAEDA

Merged r19068 from trunk to 4.1-stable (#16904).

History

#1 - 2014-05-16 16:01 - Felix Schäfer

This adds the option to search for issues with the author "Anonymous" everywhere.

diff --git a/app/models/issue_query.rb b/app/models/issue_query.rb

index bf90f56..1b9bf1e 100644

--- a/app/models/issue_query.rb

+++ b/app/models/issue_query.rb

@@ -171,6 +171,7 @@ class IssueQuery < Query

     author_values = []

     author_values << ["<< #{l(:label_me)} >>", "me"] if User.current.logged?

     author_values += users.collect{|s| [s.name, s.id.to_s] }

+    author_values << [l(:label_user_anonymous), User.anonymous.id.to_s]

     add_available_filter("author_id",

       :type => :list, :values => author_values

     ) unless author_values.empty?

#2 - 2014-10-25 00:26 - Deoren Moor
+1

This would be useful to have. In addition (probably a separate issue), being able to filter on locked accounts would be nice to have as well.

#3 - 2018-10-03 03:41 - Go MAEDA

- Category set to Issues filter

#4 - 2018-10-04 05:07 - Yuichi HARADA

- File 16904-issuequery-filters-add-anonymous-user.patch added

I added an Anonymous user to the issues filter for "Author" and "Updated by" and "Last updated by".

#5 - 2018-10-04 17:19 - Go MAEDA

- Target version set to Candidate for next major release

#6 - 2018-11-03 08:40 - Go MAEDA

- File 16904-issuequery-filters-add-anonymous-user-v2.patch added

Thank you for writing the patch.

But I think that not only IssuesQuery but also TimeEntryQuery should have an anonymous user in the author list because the User value of time

entries can be an anonymous user.

#7 - 2019-11-10 03:06 - Go MAEDA

- Target version changed from Candidate for next major release to 4.1.0

Setting the target version to 4.1.0.

#8 - 2019-11-10 09:00 - Jean-Philippe Lang

- Subject changed from Add anonymous user to author list in issue query to Add anonymous user to users list in query filters

- Status changed from New to Closed

- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Committed, thanks.

#9 - 2019-11-10 13:13 - Marius BĂLTEANU

- File 16904.patch added

- Status changed from Closed to Reopened

A test is failling:

root@df2fd1389bf4:/work# ruby test/functional/queries_controller_test.rb -n test_user_filter_should_return_act

ive_and_locked_users_grouped_by_status

Run options: -n test_user_filter_should_return_active_and_locked_users_grouped_by_status --seed 49890

# Running:

F

Failure:

QueriesControllerTest#test_user_filter_should_return_active_and_locked_users_grouped_by_status [test/functiona

l/queries_controller_test.rb:778]:

Expected: 6

Actual: 7

 and a new Rubocop offense:

root@df2fd1389bf4:/work# bundle exec rubocop test/functional/queries_controller_test.rb 

Inspecting 1 file

C

Offenses:
test/functional/queries_controller_test.rb:764:34: C: Style/RedundantInterpolation: Prefer to_s over string in

terpolation.

    assert_include ["Anonymous", "#{User.anonymous.id}"], json

                                 ^^^^^^^^^^^^^^^^^^^^^^

1 file inspected, 1 offense detected

 The attach patch fixes both issues.

#10 - 2019-11-13 14:26 - Go MAEDA

- Status changed from Reopened to Closed

Committed the fix 16904.patch. Thank you.

#11 - 2019-11-13 16:01 - Toshi MARUYAMA

- Status changed from Closed to Reopened

Tests fail on PostgreSQL.

http://www.redmine.org/builds/logs/build_trunk_postgresql_ruby-2.6_795.html

#12 - 2019-11-13 16:06 - Marius BĂLTEANU

- Status changed from Reopened to Closed

Toshi MARUYAMA wrote:

Tests fail on PostgreSQL.

http://www.redmine.org/builds/logs/build_trunk_postgresql_ruby-2.6_795.html

 It is a known issue, please see #32436.

Files

16904-issuequery-filters-add-anonymous-user.patch 1.91 KB 2018-10-04 Yuichi HARADA

16904-issuequery-filters-add-anonymous-user-v2.patch 1.34 KB 2018-11-03 Go MAEDA

16904.patch 1.06 KB 2019-11-10 Marius BĂLTEANU
